def naive_concatenate(destination, source, destination_offset, source_offset):
    while source_offset < len(source):
        destination[destination_offset] = source[source_offset]
        destination_offset += 1
        source_offset += 1
    return destination


def in_place_concatenate(destination, source, destination_offset, source_offset):
    to_concat = source[source_offset:]
    destination[destination_offset : destination_offset + len(to_concat)] = to_concat
    return destination


def new_list_concatenate(destination, source, destination_offset, source_offset):
    to_concat = source[source_offset:]
    return (
        destination[:destination_offset]
        + to_concat
        + destination[destination_offset + len(to_concat) :]
    )
